#!/usr/lbin/perl
# revoke_header.pl
# Invoked from the whatnow prompt by using the -revoke argument with
# the send command.  X-Revoke headers and are generated and attached
# to the draft and local revocation mail folder.

require '/u/mualice/revoke/revokelib.pl';
require 'ctime.pl';

# Pass draft filename to header/body parser
chop($path=`mhparam path`);
if ($path=~/^$/) { $path="Mail"; }
$draft="$ENV{'HOME'}/$path/draft"; 
# Note that this draft filename is hard coded into MH (I think)
# But if you use a draft folder, this code will need changing

# Grab headers and body
open(DRAFT,$draft) || die "Can't open $file";    
%header=&revokelib'parse_message(*DRAFT,$body,$separator,$header_string);
close(DRAFT);
# Since we should keep headers in the same order they were read in.
# (Assoc. array don't preserve order)
@ordered_header=split(':',$header_string);

# Escape out "From" when it begins a line and is followed by a space.
# (periods are handled internally by MTA's)
@lines=split('\n',$body);
$newbody="";
foreach $line (@lines)
{
    $line=~s/^From\x20/>From\x20/;
    $newbody.="$line\n";
}

# Compute the MD5 hash of headers and body
# Because "From" and "Date" aren't yet in the draft, create new
# headers.  (The MTA adds the "From" and "Date" headers in the
# DATA portion of a SMTP transfer.)
push(@ordered_header,"X-Revoke-From","X-Revoke-Date");
$header{'X-Revoke-From'}=$ENV{'USER'};
chop($header{'X-Revoke-Date'}=&ctime(time));

&revokelib'md5_message($newbody,$hash,%header);
print "MD5 hash: $hash\n";
# Generate session key and encrypt the hash
&revokelib'get_params($sequence,$seed);
&revokelib'gen_session_key($sequence,$seed);
&revokelib'store_params($sequence,$seed);
&revokelib'des($hash,$seed,1,$out);

push(@ordered_header,"X-Revoke-Hash");
$header{'X-Revoke-Key'}=$seed;
$header{'X-Revoke-Hash'}=$out;

# Store temp draft w/ prepended X-Revoke-Date, X-Revoke-From, 
# X-Revoke-To, X-Revoke-Key, X-Revoke-Hash headers, modified body
chop($temp=`mhparam mhtemp`);
if ($temp=~/^$/) { $temp="temp"; }

open(TEMP,">$ENV{'HOME'}/$path/$temp");
foreach $key (@ordered_header)
{ print TEMP "$key: $header{$key}\n"; }
print TEMP "X-Revoke-Key: $header{'X-Revoke-Key'}\n";
print TEMP "$separator\n";
print TEMP "$newbody\n";
close (TEMP);

# Copy temp draft to revocation folder
print `refile -file $ENV{'HOME'}/$path/$temp +revoke`;

# Remove X-Revoke-Key header, save modified draft 
# (to be sent to recipient(s)).
#$header{'X-Revoke-Key'}="";
open(DRAFT,">$ENV{'HOME'}/$path/draft");
foreach $key (@ordered_header)
{ print DRAFT "$key: $header{$key}\n"; }
print DRAFT "$separator\n";
print DRAFT "$newbody\n";
close (DRAFT);

$tempto=$header{'To'};
$tempto=~s/(.*)\@.*$/$1/;
print "Key: >$header{'X-Revoke-Key'}<\n";
print "To: >$tempto<\n";
print "X-Revoke-From: >$header{'X-Revoke-From'}<\n";
print "X-Revoke-Date: >$header{'X-Revoke-Date'}<\n";
print "Subject: >$header{'Subject'}<\n";
print "Body: >$newbody<\n";

