#!/usr/local/bin/perl4.036
# Note that the path to perl must be for the MAIL HUB! (not necessarily
# your workstation)

# revoke_receive.pl
# Program to parse received revocation command mail and execute checks
# and revocations.  Read the slocal man page, as is describes the severely
# limited environment this program runs in.

require '/u/mualice/revoke/revokelib.pl';

$MessageNotRead="The message has not been read.";
$MessageRevoked="The message has been revoked.";
$MessageBadRequest="Your request is not understood.";
$MessageBadKey="The message has already been read.";

$receive_arg=$ARGV[0];  # This gets the first arg

open(LOG,">$ENV{'HOME'}/revokelog");
print LOG "Arg: $receive_arg\n";
# Parse headers.  
%cmd_header=&revokelib'parse_message(*STDIN,$body,$separator,$header_string);
print LOG "Got headers.\n";
print LOG "Hash: $cmd_header{'X-Revoke-Hash'}\n";

# Check for hash in spool.  Right now, "Message has been read" messages
# are sent to the requestor, even though the requestor might not be
# authorized.  (The "raise your hand if you're not here" problem)

# This spool variable is tricky on machines that use mail hubs (not the
# local machine) for receiving mail.  The path must be that of what's
# on the mail hub! (/var/mail/user vs. /usr/spool/mail/user)
$spool="/var/mail/$ENV{'USER'}";

%spool_header=&revokelib'grab_message($spool,$cmd_header{'X-Revoke-Hash'},
              $spool_body,$found);
print LOG "Foundage: $found\n";
$tempto=$spool_header{'To'};
$tempto=~s/(.*)\@.*$/$1/;
print LOG "To: >$tempto<\n";
print LOG "X-Revoke-From: >$spool_header{'X-Revoke-From'}<\n";
print LOG "X-Revoke-Date: >$spool_header{'X-Revoke-Date'}<\n";
print LOG "Subject: >$spool_header{'Subject'}<\n";
print LOG "Body: >$spool_body<\n";
if (! $found) 
{ print LOG "Not Found!\n";
  &revokelib'reply($MessageBadKey,$body,$separator,%cmd_header); 
  exit 0;
}

print LOG "Found!\n";
while (($key,$value)=each (%spool_header))
{    print LOG "$key: $spool_header{$key}\n";}
print LOG "Spool Body: >$spool_body<\n";

# Message has not been read, now verify identity of sender
&revokelib'md5_message($spool_body,$hash,%spool_header);
print LOG "MD5 hash: $hash\n";
&revokelib'des($hash,$cmd_header{'X-Revoke-Key'},1,$out);
print LOG "Key: >$cmd_header{'X-Revoke-Key'}<\n";
print LOG "Request's Hash: $cmd_header{'X-Revoke-Hash'}\n";
print LOG "Our computed  : $out\n";
if ($out eq $cmd_header{'X-Revoke-Hash'})
{   print LOG "Indentity verified: OK\n";
    # Verified!  Check message for revocation command (Check, Revoke)
    if ($receive_arg=~/^check$/i)
    {
	print LOG "Sending *not read* message.\n";
        print LOG ("Spool: ",`/usr/ucb/ls -l $spool`,"\n");
	# Reply message is not yet read
	&revokelib'reply($MessageNotRead,$body,$separator,%cmd_header);
    }
    elsif ($receive_arg=~/^revoke$/i)
    {
	print LOG "Sending *revoked* message.\n";
        &revokelib'remove_message($spool,$cmd_header{'X-Revoke-Hash'});
	&revokelib'reply($MessageRevoked,$body,$separator,%cmd_header);
    }
    else
    {
        # If not (check,revoke), return to sender.
	print LOG "Bad request (not check/revoke).\n";
	&revokelib'reply($MessageBadRequest,$body,$separator,%cmd_header);
    }
    # Replace the hash with the newone in the spool to thwart reply-attacks.
    &revokelib'replace_hash($spool,$cmd_header{'X-Revoke-Hash'},
                                   $cmd_header{'X-Revoke-New-Hash'});
}
else
{
    # False identity claim and message not read.
    print LOG "Hey, this request is *not* valid!  Thief!\n";
    &revokelib'reply($MessageBadKey,$body,$separator,%cmd_header);
}
