#!/usr/lbin/perl

# revoke_send.pl
# This program sends revoke/check messages.  Arguments are first either
# "check" or "revoke" and then the message number(s) of the messages to
# check or revoke.

require '/u/mualice/revoke/revokelib.pl';

($cmd,@msgs)=@ARGV;
chop($path=`mhparam path`);
if ($path=~/^$/) { $path="Mail"; }
chop($folder=`mhparam mhrevokefolder`); # revoke
if ($folder=~/^$/) { $folder="revoke"; }

$cmd=~s/^.*(check|revoke).*$/\1/i;  # Make cmd either check, revoke, or null
$cmd=~tr/A-Z/a-z/;

if ($cmd)
{
    # Perform check
    if ($cmd eq "check") {print "This is a check on @msgs.\n";}
    else {print "This is a revocation on @msgs.\n";}
    foreach $msgnum (@msgs)
    {
	$message="$ENV{'HOME'}/$path/$folder/$msgnum";
	if (-e $message)
	{
	    if ($cmd eq "check") {print "Checking $message.\n"; }
	    else {print "Revoking $message.\n";}
	    open(MESSAGE,$message);
	    %header=&revokelib'parse_message(*MESSAGE,$body,$separator,$header_string);
            close(MESSAGE);
            @ordered_header=split(':',$header_string);
            
            $oldhash=$header{'X-Revoke-Hash'};
            $oldkey=$header{'X-Revoke-Key'};

            # Generate a new key and encrypt old hash; store. 
            &revokelib'get_params($sequence,$seed);
            &revokelib'gen_session_key($sequence,$seed);
            &revokelib'store_params($sequence,$seed);
	    &revokelib'des($oldhash,$oldkey,0,$md5_hash);
            &revokelib'des($md5_hash,$seed,1,$out);
            $header{'X-Revoke-Key'}=$seed;
            $header{'X-Revoke-Hash'}=$out;

            open(MESSAGE,">$message");
            foreach $key (@ordered_header)
            { print MESSAGE "$key: $header{$key}\n"; }
            print MESSAGE "$separator\n";
            print MESSAGE "$body\n";
            close (MESSAGE);

            # Send the check message: create a draft, call MH's send.
            open(DRAFT,">$ENV{'HOME'}/$path/draft");
            print DRAFT "To: $header{'To'}\n";
            print DRAFT "X-Revoke-Command: $cmd\n"; 
	    print DRAFT "X-Revoke-Hash: $oldhash\n";
	    print DRAFT "X-Revoke-New-Hash: $header{'X-Revoke-Hash'}\n";
            print DRAFT "X-Revoke-Key: $oldkey\n";
            close(DRAFT);
            `send -draft`;
	}
	else
	{ die "Unable to find $message.\n"; }
    }
}
else 
{ 
    die "Check or Revoke argument not specified.  Proper use:\n revoke_send.pl [check|revoke] msgnums\n"; }

    


