#!/usr/lbin/perl

# Test the revokelib.pl routines

require 'revokelib.pl';

$file=$ARGV[0];

print "\n\nPARSE_MESSAGE_TEST:\n";
&test_parse_message($file);
print "\n\nMD5 TEST:\n";
&test_md5($file);
print "\n\nDES'D MD5 TEST:\n";
&test_des($file);
print "\n\nREPLACE_HASH TEST:\n";
&test_replace_hash($file,"foo","bar");

sub test_replace_hash
{
    local($file,$old,$new)=@_;
    &revokelib'replace_hash($file,$old,$new);
}

sub test_des # ($file)
{
    local($file)=@_;
    open(FILE,$file);
    %header=&revokelib'parse_message(*FILE,$body,$separator,$header_string);
    close(FILE);
    &revokelib'md5_message($body,$hash,%header);
    print "MD5 Hash: $hash\n";
    &revokelib'get_params($sequence,$seed);
    print "Sequence: $sequence\nSeed: $seed\n";
    &revokelib'gen_session_key($sequence,$seed);
    print "New Sequence: $sequence\nNew Seed: $seed\n";
    &revokelib'store_params($sequence,$seed);
    &revokelib'des($hash,$seed,1,$out);
    print "DES Ciphertext: $out\n";
    &revokelib'des($out,$seed,0,$original);
    print "DES Plaintext: $original\n";
    if ($original eq $hash) { $match="YES"; } else {$match="NO";}
    print "Match: $match\n";
}

sub test_md5 # ($file)
{
    local($file)=@_;
    open(FILE,$file);
    %header=&revokelib'parse_message(*FILE,$body,$separator,$header_string);
    close(FILE);
    &revokelib'md5_message($body,$hash,%header);
    print "MD5 Hash: $hash\n";
}

sub test_parse_message # ($file)
{
    local($file)=@_;
    open(FILE,$file);
    %header=&revokelib'parse_message(*FILE,$body,$separator,$header_string);
    close(FILE);
    @ordered_header=split(':',$header_string);

    foreach $key (@ordered_header)
    {
        print "\"$key\" -> \"$header{$key}\"\n";
    }
    print "------Body Text------\n";
    print "$body";
    print "------Body Text------\n";
}


